unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Grids, ComCtrls, Jpeg, ZLib, GifImage, OleCtnrs, ExtDlgs,
  ExtCtrls, Tabs, Menus, FileCtrl, Buttons, ShellAPI, DataCollection;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Notebook1: TNotebook;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Commands1: TMenuItem;
    Add1: TMenuItem;
    N1: TMenuItem;
    Delete1: TMenuItem;
    Clear1: TMenuItem;
    Strings1: TMenuItem;
    Bitmap1: TMenuItem;
    Stream1: TMenuItem;
    Icon1: TMenuItem;
    File2: TMenuItem;
    Buffer1: TMenuItem;
    JPegImage1: TMenuItem;
    GifImage1: TMenuItem;
    OLE1: TMenuItem;
    Richedit1: TMenuItem;
    Panel1: TPanel;
    SpinEdit1: TSpinEdit;
    OpenPictureDialog1: TOpenPictureDialog;
    OpenPictureDialog2: TOpenPictureDialog;
    OpenDialog2: TOpenDialog;
    OpenPictureDialog3: TOpenPictureDialog;
    OpenPictureDialog4: TOpenPictureDialog;
    Memo1: TMemo;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Image2: TImage;
    ScrollBox2: TScrollBox;
    Image3: TImage;
    ScrollBox3: TScrollBox;
    Image4: TImage;
    OleContainer1: TOleContainer;
    RichEdit2: TRichEdit;
    N2: TMenuItem;
    Compression1: TMenuItem;
    None1: TMenuItem;
    Fastest1: TMenuItem;
    Default1: TMenuItem;
    Maximum1: TMenuItem;
    N3: TMenuItem;
    Deletemarked1: TMenuItem;
    OpenDialog3: TOpenDialog;
    Insert1: TMenuItem;
    Strings2: TMenuItem;
    Bitmap2: TMenuItem;
    Stream2: TMenuItem;
    Icon2: TMenuItem;
    File3: TMenuItem;
    Buffer2: TMenuItem;
    JPegimage2: TMenuItem;
    Gifimage2: TMenuItem;
    OLE2: TMenuItem;
    Richedit3: TMenuItem;
    Label4: TLabel;
    DirectoryListBox1: TDirectoryListBox;
    Label5: TLabel;
    Label6: TLabel;
    DriveComboBox1: TDriveComboBox;
    SpeedButton1: TSpeedButton;
    Label7: TLabel;
    Label8: TLabel;
    Loadall1: TMenuItem;
    Change1: TMenuItem;
    Strings3: TMenuItem;
    Bitmap3: TMenuItem;
    Stream3: TMenuItem;
    Icon3: TMenuItem;
    File4: TMenuItem;
    JPegimage3: TMenuItem;
    Gifimage3: TMenuItem;
    OLE3: TMenuItem;
    Richedit4: TMenuItem;
    N4: TMenuItem;
    Undeleteall1: TMenuItem;
    Buffer3: TMenuItem;
    Unloadall1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    N5: TMenuItem;
    OpenDialog4: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Settings1: TMenuItem;
    Dropprocedure1: TMenuItem;
    Addfilesasafiletype1: TMenuItem;
    Determinetypebyitsextension1: TMenuItem;
    N6: TMenuItem;
    Dontaddfilesofunknowntype1: TMenuItem;
    Label27: TLabel;
    Label28: TLabel;
    N7: TMenuItem;
    Help1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Strings1Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure Bitmap1Click(Sender: TObject);
    procedure Icon1Click(Sender: TObject);
    procedure File2Click(Sender: TObject);
    procedure JPegImage1Click(Sender: TObject);
    procedure GifImage1Click(Sender: TObject);
    procedure OLE1Click(Sender: TObject);
    procedure None1Click(Sender: TObject);
    procedure Fastest1Click(Sender: TObject);
    procedure Default1Click(Sender: TObject);
    procedure Maximum1Click(Sender: TObject);
    procedure Deletemarked1Click(Sender: TObject);
    procedure Richedit1Click(Sender: TObject);
    procedure Strings2Click(Sender: TObject);
    procedure Bitmap2Click(Sender: TObject);
    procedure Icon2Click(Sender: TObject);
    procedure File3Click(Sender: TObject);
    procedure JPegimage2Click(Sender: TObject);
    procedure Gifimage2Click(Sender: TObject);
    procedure Richedit3Click(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Loadall1Click(Sender: TObject);
    procedure Strings3Click(Sender: TObject);
    procedure Bitmap3Click(Sender: TObject);
    procedure Icon3Click(Sender: TObject);
    procedure File4Click(Sender: TObject);
    procedure JPegimage3Click(Sender: TObject);
    procedure Gifimage3Click(Sender: TObject);
    procedure Richedit4Click(Sender: TObject);
    procedure Undeleteall1Click(Sender: TObject);
    procedure Unloadall1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Dontaddfilesofunknowntype1Click(Sender: TObject);
    procedure Addfilesasafiletype1Click(Sender: TObject);
    procedure Determinetypebyitsextension1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
  private
    procedure WMDropFiles( var Msg: TMessage );message WM_DROPFILES;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var
  DC: TDataCollection;
  Comp: TCompression = C_FASTEST;

function Error( a: Byte ): Boolean;
begin
  Result := true;
  Form1.Label28.caption := '/';
  case a of
    1: Form1.Label28.caption := 'Index out of range!';
    2: Form1.Label28.caption := 'Data missing!';
    3: Form1.Label28.caption := 'Read beyond end of file!';
    4: Form1.Label28.caption := 'CRC mismatch!';
    5: Form1.Label28.caption := 'Item not found!';
    6: Form1.Label28.caption := 'Invalid item order!';
    7: Form1.Label28.caption := 'Object not created!';
    8: Form1.Label28.caption := 'Allready created!';
    9: Form1.Label28.caption := 'Name allready exists!';
    10: Form1.Label28.caption := 'Header empty!';
    11: Form1.Label28.caption := 'Size mismatch!';
    12: Form1.Label28.caption := 'Invalid header!';
    13: Form1.Label28.caption := 'File doesn''t exists!';
    14: Form1.Label28.caption := 'Error opening file!';
    15: Form1.Label28.caption := 'Error closing file!';
    16: Form1.Label28.caption := 'Write error!';
    17: Form1.Label28.caption := 'Read error!';
    18: Form1.Label28.caption := 'Invalid file!';
    19: Form1.Label28.caption := 'Invalid code!';
    20: Form1.Label28.caption := 'Data type mismatch!';
    21: Form1.Label28.caption := 'Object empty!';
    22: Form1.Label28.caption := 'Invalid file version!';
  else
    Form1.Label28.caption := '/';
    Result := false;
  end;
end;

procedure UpdateInfo;
var
  Info: TItemInfo;
  a: Longint;
begin
  Form1.Label14.Caption := IntToStr( DC.Count );
  if DC.Count = 0 then Form1.Notebook1.PageIndex := 10;
  begin
    if error( DC.GetItemInfo( Form1.SpinEdit1.Value, Info ) ) then Exit;
    a := Info.Size;
    if a < 0 then
      Form1.Label15.Caption := '/';
    if ( a < 1024 ) and ( a > -1 ) then
      Form1.Label15.Caption := IntToStr( a ) + ' bytes';
    if a > 1024 then
      Form1.Label15.Caption := IntToStr( a div 1024 ) + ' kB';
    case info.Compression of
      C_NONE: Form1.Label16.Caption := 'None';
      C_FASTEST: Form1.Label16.Caption := 'Fastest';
      C_DEFAULT: Form1.Label16.Caption := 'Default';
      C_MAX: Form1.Label16.Caption := 'Maximum';
    end;
    Form1.Label17.Caption := IntToStr( Info.Ratio ) + '%';
    if Info.Loaded then
      Form1.Label18.Caption := 'Yes' else
      Form1.Label18.Caption := 'No';
    case Info.DataType of
      DT_STRINGS: Form1.Label19.caption := 'Strings';
      DT_BITMAP: Form1.Label19.caption := 'Bitmap';
      DT_STREAM: Form1.Label19.caption := 'Stream';
      DT_ICON: Form1.Label19.caption := 'Icon';
      DT_FILE: Form1.Label19.caption := 'File';
      DT_BUFFER: Form1.Label19.caption := 'Buffer';
      DT_JPEG: Form1.Label19.caption := 'JPeg image';
      DT_GIF: Form1.Label19.caption := 'Gif image';
      DT_OLE: Form1.Label19.caption := 'OLE object';
      DT_RICH: Form1.Label19.caption := 'Rich text';
    else
      Form1.Label19.caption := 'Unknown';
    end;
  end;
  a := DC.GetMemoryUsage;
  if a < 1024 then
    Form1.Label22.Caption := IntToStr( a ) + ' bytes';
  if ( a > 1024 ) and ( a < ( 1024 * 1024 ) ) then
    Form1.Label22.Caption := IntToStr( a div 1024 ) + ' kB';
  if a > 1024 * 1024 then
    Form1.Label22.Caption := IntToStr( a div 1024 ) + ' kB';
  Form1.Label24.Caption := IntToStr( DC.DeleteCount );
  a := DC.GetFileSize;
  if a < 1024 then
    Form1.Label26.caption := IntToStr( a ) + ' bytes';
  if a > 1024 then
    Form1.Label26.caption := IntToStr( a div 1024 ) + ' kB';
  Form1.SpinEdit1.MaxValue := DC.Count - 1;
  Application.Processmessages;
end;

procedure TForm1.WMDropFiles( var Msg: TMessage );
var
  a, Count, BufSize: Integer;
  p: pChar;
  s, h: String;
  dt: TDataType;
  Itemdata: pItemdata;
  Strings: TStrings;
  Bitmap: TBitmap;
  Icon: TIcon;
  JPeg: TJPegImage;
  Gif: TGifImage;
  Rich: TRichEdit;
  data: pItemData;
begin
  SpinEdit1.Value := 0;
  DC.Compression := Comp;
  Count := DragQueryFile( Msg.wParam, $ffffffff, nil, 0 );
  for a := 0 to Count - 1 do
  begin
    BufSize := DragQueryFile( Msg.wParam, a, nil, 0 ) + 1;
    GetMem( p, BufSize );
    DragQueryFile( Msg.wParam, a, p, BufSize );
    if Addfilesasafiletype1.checked then
    begin
      New( itemdata );
      s := StrPas( p );
      Itemdata.StrValue := s;
      error( DC.Add( s, itemdata ) );
      Dispose( Itemdata );
    end else
    begin
      s := StrPas( p );
      h := Uppercase( Copy( s, Length( s ) - 2, 3 ) );
      dt := DT_BUFFER;
      if h = 'TXT' then dt := DT_STRINGS;
      if h = 'BMP' then dt := DT_BITMAP;
      if h = 'ICO' then dt := DT_ICON;
      if h = 'JPG' then dt := DT_JPEG;
      if h = 'GIF' then dt := DT_GIF;
      if h = 'OLE' then dt := DT_OLE;
      if h = 'RTF' then dt := DT_RICH;
      case dt of
        DT_STRINGS:
        begin
          Strings := TStringList.Create;
          try
            Strings.LoadFromFile( s );
          except

          end;
          New( data );
          Data.StrValue := s;
          error( DC.Add( Strings, data ) );
          Dispose( Data );
          Strings.Free;
        end;
        DT_BITMAP:
        begin
          Bitmap := TBitmap.Create;
          try
            Bitmap.LoadFromFile( s );
          except

          end;
          New( data );
          Data.StrValue := s;
          error( DC.Add( Bitmap, data ) );
          Dispose( Data );
          Bitmap.Free;
        end;
        DT_ICON:
        begin
          Icon := TIcon.Create;
          try
            Icon.LoadFromFile( s );
          except

          end;
          New( data );
          Data.StrValue := s;
          error( DC.Add( Icon, data ) );
          Dispose( Data );
          Icon.free;
        end;
        DT_JPEG:
        begin
          Jpeg := TJpegImage.Create;
          try
            JPeg.LoadFromFile( s );
          except

          end;
          New( data );
          Data.StrValue := s;
          error( DC.Add( JPeg, data ) );
          Dispose( Data );
          JPeg.Free;
        end;
        DT_GIF:
        begin
          Gif := TGifImage.Create;
          try
            Gif.LoadFromFile( s );
          except

          end;
          New( data );
          Data.StrValue := s;
          error( DC.Add( gif, data ) );
          Dispose( Data );
          Gif.Free;
        end;
        DT_OLE:
        begin
        end;
        DT_RICH:
        begin
          Rich := TRichEdit.Create( self );
          Rich.Visible:= false;
          Rich.Parent := Form1;
          try
            Rich.Lines.LoadFromFile( s );
          except

          end;
          New( data );
          Data.StrValue := s;
          error( DC.Add( Rich, data ) );
          Dispose( Data );
          Rich.Free;
        end;
        DT_BUFFER:
        begin
          if not Dontaddfilesofunknowntype1.Checked then
          begin
            New( data );
            data^.Strvalue := s;
            error( DC.Add( s, data ) );
            Dispose( data );
          end;
        end;
      end;
    end;
    FreeMem( p );
    UpdateInfo;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  NoteBook1.Pageindex := 10;
  Comp := C_FASTEST;
  Label14.Caption := '';
  Label15.Caption := '';
  Label16.Caption := '';
  Label17.Caption := '';
  Label18.Caption := '';
  Label19.Caption := '';
  Label22.Caption := '';
  Label24.Caption := '';
  Label26.Caption := '';
  DragAcceptFiles( Handle, true );
end;

procedure TForm1.Clear1Click(Sender: TObject);
begin
  DC.Clear;
  UpdateInfo;
end;

procedure TForm1.Delete1Click(Sender: TObject);
begin
  if error( dc.Delete( SpinEdit1.Value ) ) then Exit;
  if SpinEdit1.Value > -1 then
    SpinEdit1.Value := SpinEdit1.Value - 1;
  UpdateInfo;
end;

procedure TForm1.Strings1Click(Sender: TObject);
var
  s: TStrings;
  a: Longint;
begin
  DC.Compression := Comp;
  if OpenDialog1.Execute then
  begin
    s := TStringList.Create;
    if OpenDialog1.Files.Count > 0 then
    for a := 0 to OpenDialog1.Files.Count - 1 do
    begin
      s.LoadFromFile( OpenDialog1.Files[a] );
      if s.Count = 0 then Continue;
      if error( DC.Add( s, nil ) ) then Exit;
      UpdateInfo;
    end;
    s.free;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
var
  info: TItemInfo;
  s: TStrings;
  b: TBitmap;
  i: TIcon;
  j: TJpegImage;
  g: TGifImage;
begin
  if not DC.IsCreated then Exit;
  if DC.Count = 0 then Exit;
  if error( dc.GetItemInfo( SpinEdit1.Value, info ) ) then Exit;
  case Info.DataType of
    DT_STRINGS:
    begin
      NoteBook1.PageIndex := 0;
      s := TStringList.Create;
      if error( dc.read( SpinEdit1.Value, s ) ) then Exit;
      memo1.Lines := s;
      memo1.Repaint;
      s.free;
    end;
    DT_BITMAP:
    begin
      NoteBook1.PageIndex := 1;
      b := TBitmap.Create;
      if error( dc.read( SpinEdit1.Value, b ) ) then Exit;
      Image1.Picture.Bitmap.Assign( b );
      Image1.Width := Image1.Picture.Bitmap.Width;
      Image1.Height := Image1.Picture.Bitmap.Height;
      Image1.Repaint;
      b.Free;
    end;
    DT_STREAM:
    begin
      NoteBook1.PageIndex := 2;
    end;
    DT_ICON:
    begin
      NoteBook1.PageIndex := 3;
      i := TIcon.create;
      if error( dc.read( SpinEdit1.Value, i ) ) then Exit;
      Image2.Picture.Icon.Assign( i );
      Image2.repaint;
      i.Free;
      Image2.Width := Image2.Picture.Icon.Width;
      Image2.Height := Image2.Picture.Icon.Height;
    end;
    DT_FILE:
    begin
      NoteBook1.PageIndex := 4;
      Label4.Caption := info.StrValue;
      Label6.caption := DirectoryListBox1.Directory + '\' + ExtractFileName( Label4.Caption );
    end;
    DT_BUFFER:
    begin
      NoteBook1.PageIndex := 5;
    end;
    DT_JPEG:
    begin
      NoteBook1.PageIndex := 6;
      j := TJpegImage.Create;
      if error( dc.read( SpinEdit1.Value, j ) ) then Exit;
      Image3.Picture.Bitmap.Assign( j );
      Image3.Width := Image3.Picture.Bitmap.Width;
      Image3.Height := Image3.Picture.Bitmap.Height;
      Image3.Repaint;
      j.Free;
    end;
    DT_GIF:
    begin
      NoteBook1.PageIndex := 7;
      g := TGifImage.Create;
      if error( dc.read( SpinEdit1.Value, g ) ) then Exit;
      Image4.Picture.Bitmap.Assign( g );
      Image4.Width := Image4.Picture.Bitmap.Width;
      Image4.Height := Image4.Picture.Bitmap.Height;
      Image4.Repaint;
      g.Free;
    end;
    DT_OLE:
    begin
      NoteBook1.PageIndex := 8;
      if error( dc.read( SpinEdit1.Value, OleContainer1 ) ) then Exit;
    end;
    DT_RICH:
    begin
      NoteBook1.PageIndex := 9;
      if error( dc.Read( SpinEdit1.Value, RichEdit2 ) ) then Exit;
    end;
  end;
  UpdateInfo;
end;

procedure TForm1.Bitmap1Click(Sender: TObject);
var
  b: TBitmap;
  a: Longint;
begin
  DC.Compression := Comp;
  if OpenPictureDialog1.Execute then
  begin
    b := TBitmap.Create;
    if OpenPictureDialog1.Files.Count > 0 then
    for a := 0 to OpenPictureDialog1.Files.Count - 1 do
    begin
      b.LoadFromFile( OpenPictureDialog1.Files[a] );
      if b.Empty then Continue;
      if error( DC.Add( b, nil ) ) then Exit;
      UpdateInfo;
    end;
    b.free;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.Icon1Click(Sender: TObject);
var
  i: TIcon;
  a: Longint;
begin
  DC.Compression := Comp;
  if OpenPictureDialog2.Execute then
  begin
    i := TIcon.Create;
    if OpenPictureDialog2.Files.Count > 0 then
    for a := 0 to OpenPictureDialog2.Files.Count - 1 do
    begin
      i.LoadFromFile( OpenPictureDialog2.Files[a] );
      if i.Empty then Continue;
      if error( DC.Add( i,nil ) ) then Exit;
      UpdateInfo;
    end;
    i.free;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.File2Click(Sender: TObject);
var
  a: Longint;
  ItemData: pItemdata;
begin
  DC.Compression := Comp;
  if OpenDialog2.Execute then
  begin
    if OpenDialog2.Files.Count > 0 then
    for a := 0 to OpenDialog2.Files.Count - 1 do
    begin
      New( itemdata );
      Itemdata.Strvalue := OpenDialog2.Files[a];
      itemdata.IntValue := 0;
      if error( DC.Add( OpenDialog2.Files[a], Itemdata ) ) then Exit;
      Dispose( itemdata );
      UpdateInfo;
    end;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.JPegImage1Click(Sender: TObject);
var
  j: TJpegImage;
  a: Longint;
begin
  DC.Compression := Comp;
  if OpenPictureDialog3.Execute then
  begin
    j := TJpegImage.Create;
    if OpenPictureDialog3.Files.Count > 0 then
    for a := 0 to OpenPictureDialog3.Files.Count - 1 do
    begin
      j.LoadFromFile( OpenPictureDialog3.Files[a] );
      if j.Empty then Continue;
      if error( DC.Add( j, nil ) ) then Exit;
      UpdateInfo;
    end;
    j.free;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.GifImage1Click(Sender: TObject);
var
  g: TGifImage;
  a: Longint;
begin
  DC.Compression := Comp;
  if OpenPictureDialog4.Execute then
  begin
    g := TGifImage.Create;
    if OpenPictureDialog4.Files.Count > 0 then
    for a := 0 to OpenPictureDialog4.Files.Count - 1 do
    begin
      g.LoadFromFile( OpenPictureDialog4.Files[a] );
      if g.Empty then Continue;
      if error( DC.Add( g, nil ) ) then Exit;
      UpdateInfo;
    end;
    g.free;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.OLE1Click(Sender: TObject);
begin
{  DC.Compression := Comp;
  NoteBook1.PageIndex := 8;
  TabSet1.TabIndex := 8;
  OleContainer1.InsertObjectDialog;
  if OleContainer1.NewInserted then
    OleContainer1.DoVerb(ovShow);
  if error( DC.Add( OleContainer1, 0 ) ) then Exit;
  Caption := 'Items: ' + IntToStr( DC.Count ) + ' / Filesize: ' + IntToStr( DC.GetFileSize div 1024 ) + 'kB' ;
  OleContainer1.DestroyObject;
  SpinEdit1.MaxValue := dc.Count - 1;}
end;

procedure TForm1.None1Click(Sender: TObject);
begin
  (Sender as TMenuItem).Checked := true;
  Comp := C_NONE;
end;

procedure TForm1.Fastest1Click(Sender: TObject);
begin
  (Sender as TMenuItem).Checked := true;
  Comp := C_FASTEST;
end;

procedure TForm1.Default1Click(Sender: TObject);
begin
  (Sender as TMenuItem).Checked := true;
  Comp := C_DEFAULT;
end;

procedure TForm1.Maximum1Click(Sender: TObject);
begin
  (Sender as TMenuItem).Checked := true;
  Comp := C_MAX;
end;

procedure TForm1.Deletemarked1Click(Sender: TObject);
begin
  if error( dc.DeleteMarked ) then Exit;
  UpdateInfo;
end;

procedure TForm1.Richedit1Click(Sender: TObject);
var
  e: TRichEdit;
  a: Integer;
begin
  if OpenDialog3.Execute then
  begin
    dc.Compression := Comp;
    e := TRichEdit.Create( self );
    e.Visible := false;
    e.Parent := form1;
    for a := 0 to OpenDialog3.Files.Count - 1 do
    begin
      e.Lines.LoadFromFile( OpenDialog3.Files[a] );
      if error( dc.Add( e, nil ) ) then Exit;
      UpdateInfo;
      e.Lines.Clear;
    end;
    e.Free;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.Strings2Click(Sender: TObject);
var
  s: TStrings;
  a: Longint;
begin
  DC.Compression := Comp;
  if OpenDialog1.Execute then
  begin
    s := TStringList.Create;
    if OpenDialog1.Files.Count > 0 then
    for a := 0 to OpenDialog1.Files.Count - 1 do
    begin
      s.LoadFromFile( OpenDialog1.Files[a] );
      if s.Count = 0 then Continue;
      if error( DC.Insert( SpinEdit1.Value, s, nil ) ) then Exit;
      UpdateInfo;
    end;
    s.free;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.Bitmap2Click(Sender: TObject);
var
  b: TBitmap;
  a: Longint;
begin
  DC.Compression := Comp;
  if OpenPictureDialog1.Execute then
  begin
    b := TBitmap.Create;
    if OpenPictureDialog1.Files.Count > 0 then
    for a := 0 to OpenPictureDialog1.Files.Count - 1 do
    begin
      b.LoadFromFile( OpenPictureDialog1.Files[a] );
      if b.Empty then Continue;
      if error( DC.Insert( SpinEdit1.Value, b, nil ) ) then Exit;
      UpdateInfo;
    end;
    b.free;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.Icon2Click(Sender: TObject);
var
  i: TIcon;
  a: Longint;
begin
  DC.Compression := Comp;
  if OpenPictureDialog2.Execute then
  begin
    i := TIcon.Create;
    if OpenPictureDialog2.Files.Count > 0 then
    for a := 0 to OpenPictureDialog2.Files.Count - 1 do
    begin
      i.LoadFromFile( OpenPictureDialog2.Files[a] );
      if i.Empty then Continue;
      if error( DC.Insert( SpinEdit1.Value, i, nil ) ) then Exit;
      UpdateInfo;
    end;
    i.free;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.File3Click(Sender: TObject);
var
  a: Longint;
begin
  DC.Compression := Comp;
  if OpenDialog2.Execute then
  begin
    if OpenDialog2.Files.Count > 0 then
    for a := 0 to OpenDialog2.Files.Count - 1 do
    begin
      if error( DC.Insert( SpinEdit1.Value, OpenDialog2.Files[a], nil ) ) then Exit;
      UpdateInfo;
    end;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.JPegimage2Click(Sender: TObject);
var
  j: TJpegImage;
  a: Longint;
begin
  DC.Compression := Comp;
  if OpenPictureDialog3.Execute then
  begin
    j := TJpegImage.Create;
    if OpenPictureDialog3.Files.Count > 0 then
    for a := 0 to OpenPictureDialog3.Files.Count - 1 do
    begin
      j.LoadFromFile( OpenPictureDialog3.Files[a] );
      if j.Empty then Continue;
      if error( DC.Insert( SpinEdit1.Value, j, nil ) ) then Exit;
      UpdateInfo;
    end;
    j.free;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.Gifimage2Click(Sender: TObject);
var
  g: TGifImage;
  a: Longint;
begin
  DC.Compression := Comp;
  if OpenPictureDialog4.Execute then
  begin
    g := TGifImage.Create;
    if OpenPictureDialog4.Files.Count > 0 then
    for a := 0 to OpenPictureDialog4.Files.Count - 1 do
    begin
      g.LoadFromFile( OpenPictureDialog4.Files[a] );
      if g.Empty then Continue;
      if error( DC.Insert( SpinEdit1.Value, g, nil ) ) then Exit;
      UpdateInfo;
    end;
    g.free;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.Richedit3Click(Sender: TObject);
var
  e: TRichEdit;
  a: Integer;
begin
  if OpenDialog3.Execute then
  begin
    dc.Compression := Comp;
    e := TRichEdit.Create( self );
    e.Visible := false;
    e.Parent := form1;
    for a := 0 to OpenDialog3.Files.Count - 1 do
    begin
      e.Lines.LoadFromFile( OpenDialog3.Files[a] );
      if error( dc.Insert( SpinEdit1.Value, e, nil ) ) then Exit;
      UpdateInfo;
      e.Lines.Clear;
    end;
    e.Free;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.DirectoryListBox1Change(Sender: TObject);
begin
  if DirectoryListBox1.Directory[Length(DirectoryListBox1.Directory)] = '\' then
    Label6.caption := DirectoryListBox1.Directory + ExtractFileName( Label4.Caption ) else
    Label6.caption := DirectoryListBox1.Directory + '\' +  ExtractFileName( Label4.Caption );
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
  f: file;
begin
  AssignFile( f, DirectoryListBox1.Directory + '\' +  extractfilename( Label4.Caption ) );
  Rewrite( f );
  CloseFile( f );
  if error( dc.read( SpinEdit1.Value, DirectoryListBox1.Directory + '\' +  extractfilename( Label4.Caption ) ) ) then Exit;
end;

procedure TForm1.Loadall1Click(Sender: TObject);
var
  a: Integer;
begin
  for a := 0 to DC.Count - 1 do
  begin
    error( dc.Load( a ) );
    UpdateInfo;
  end;
end;

procedure TForm1.Strings3Click(Sender: TObject);
var
  s: TStrings;
  a: Longint;
begin
  DC.Compression := Comp;
  if OpenDialog1.Execute then
  begin
    s := TStringList.Create;
    if OpenDialog1.Files.Count > 0 then
    for a := 0 to OpenDialog1.Files.Count - 1 do
    begin
      s.LoadFromFile( OpenDialog1.Files[a] );
      if s.Count = 0 then Continue;
      if error( DC.Change( SpinEdit1.Value, s, nil ) ) then Exit;
      UpdateInfo;
    end;
    s.free;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.Bitmap3Click(Sender: TObject);
var
  b: TBitmap;
  a: Longint;
begin
  DC.Compression := Comp;
  if OpenPictureDialog1.Execute then
  begin
    b := TBitmap.Create;
    if OpenPictureDialog1.Files.Count > 0 then
    for a := 0 to OpenPictureDialog1.Files.Count - 1 do
    begin
      b.LoadFromFile( OpenPictureDialog1.Files[a] );
      if b.Empty then Continue;
      if error( DC.Change( SpinEdit1.Value, b, nil ) ) then Exit;
      UpdateInfo;
    end;
    b.free;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.Icon3Click(Sender: TObject);
var
  i: TIcon;
  a: Longint;
begin
  DC.Compression := Comp;
  if OpenPictureDialog2.Execute then
  begin
    i := TIcon.Create;
    if OpenPictureDialog2.Files.Count > 0 then
    for a := 0 to OpenPictureDialog2.Files.Count - 1 do
    begin
      i.LoadFromFile( OpenPictureDialog2.Files[a] );
      if i.Empty then Continue;
      if error( DC.Change( SpinEdit1.Value, i, nil ) ) then Exit;
      UpdateInfo;
    end;
    i.free;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.File4Click(Sender: TObject);
var
  a: Longint;
  ItemData: pItemdata;
begin
  DC.Compression := Comp;
  if OpenDialog2.Execute then
  begin
    if OpenDialog2.Files.Count > 0 then
    for a := 0 to OpenDialog2.Files.Count - 1 do
    begin
      New( itemdata );
      Itemdata.Strvalue := OpenDialog2.Files[a];
      itemdata.IntValue := 0;
      if error( DC.Change( SpinEdit1.Value, OpenDialog2.Files[a], Itemdata ) ) then Exit;
      Dispose( itemdata );
      UpdateInfo;
    end;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.JPegimage3Click(Sender: TObject);
var
  j: TJpegImage;
  a: Longint;
begin
  DC.Compression := Comp;
  if OpenPictureDialog3.Execute then
  begin
    j := TJpegImage.Create;
    if OpenPictureDialog3.Files.Count > 0 then
    for a := 0 to OpenPictureDialog3.Files.Count - 1 do
    begin
      j.LoadFromFile( OpenPictureDialog3.Files[a] );
      if j.Empty then Continue;
      if error( DC.Change( SpinEdit1.Value, j, nil ) ) then Exit;
      UpdateInfo;
    end;
    j.free;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.Gifimage3Click(Sender: TObject);
var
  g: TGifImage;
  a: Longint;
begin
  DC.Compression := Comp;
  if OpenPictureDialog4.Execute then
  begin
    g := TGifImage.Create;
    if OpenPictureDialog4.Files.Count > 0 then
    for a := 0 to OpenPictureDialog4.Files.Count - 1 do
    begin
      g.LoadFromFile( OpenPictureDialog4.Files[a] );
      if g.Empty then Continue;
      if error( DC.Change( SpinEdit1.Value, g, nil ) ) then Exit;
      UpdateInfo;
    end;
    g.free;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.Richedit4Click(Sender: TObject);
var
  e: TRichEdit;
  a: Integer;
begin
  if OpenDialog3.Execute then
  begin
    dc.Compression := Comp;
    e := TRichEdit.Create( self );
    e.Visible := false;
    e.Parent := form1;
    for a := 0 to OpenDialog3.Files.Count - 1 do
    begin
      e.Lines.LoadFromFile( OpenDialog3.Files[a] );
      if error( dc.Change( SpinEdit1.Value, e, nil ) ) then Exit;
      UpdateInfo;
      e.Lines.Clear;
    end;
    e.Free;
    SpinEdit1.MaxValue := dc.Count - 1;
  end;
end;

procedure TForm1.Undeleteall1Click(Sender: TObject);
begin
  if error( DC.UndeleteAll ) then Exit;
  UpdateInfo;
end;

procedure TForm1.Unloadall1Click(Sender: TObject);
var
  a: Integer;
begin
  for a := 0 to DC.Count - 1 do
  begin
    error( dc.UnLoad( a ) );
    UpdateInfo;
  end;
end;

procedure TForm1.New1Click(Sender: TObject);
var
  s, h: String;
  f: file;
begin
  if SaveDialog1.Execute then
  begin
    dc.Free;
    if FileExists( SaveDialog1.Filename ) then
      if MessageDlg( 'File already exists! Owerwrite?', MtWarning, [mbYes, mbNo], 0 ) = ID_NO then Exit;;
    s := '';
    h := '';
    if not InputQuery( 'Enter code', '', s ) then Exit;
    if not InputQuery( 'Enter file description', '', h ) then Exit;
    AssignFile( f, SaveDialog1.FileName );
    Rewrite( f );
    CloseFile( f );
    if error( DC.Create( SaveDialog1.FileName, s, h ) ) then Exit;
    UpdateInfo;
  end;
end;

procedure TForm1.Open1Click(Sender: TObject);
var
  s, h: String;
  f: file;
begin
  if OpenDialog4.Execute then
  begin
    AssignFile( f, OpenDialog4.FileName );
    Reset( f, 4 );
    if FileSize ( f ) = 0 then
    begin
      CloseFile( f );
      Showmessage( 'Invalid file' );
      Exit;
    end else
    begin
      CloseFile( f );
    end;
    dc.Free;
    s := '';
    if not InputQuery( 'Enter code', '', s ) then Exit;
    h := '';
    if error( DC.Create( OpenDialog4.FileName, s, h ) ) then Exit;
    UpdateInfo;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  dc.Free;
end;

procedure TForm1.Dontaddfilesofunknowntype1Click(Sender: TObject);
begin
  (Sender as TMenuItem).Checked := not (Sender as TMenuItem).Checked; 
end;

procedure TForm1.Addfilesasafiletype1Click(Sender: TObject);
begin
  (Sender as TMenuItem).Checked := true;
end;

procedure TForm1.Determinetypebyitsextension1Click(Sender: TObject);
begin
  (Sender as TMenuItem).Checked := true;
end;

procedure TForm1.Help1Click(Sender: TObject);
begin
  Showmessage( 'This window accepts dragged files and this ' + #13 + 'option will do the following:' + #13 +
               'if you check "Add files as file type", all files ' + #13 + 'are stored as files,' + #13 +
               'but, if you check "Determine type by it''s extention", '  + #13 +
               'then files with .bmp extention will be saved as bitmap,' + #13 +
               'files with .txt extention will be saved as strings,...' + #13 +
               'If "Don''t add files of unknown type" is checked, then' + #13 +
               'files with other extentions are saved as files'  );
end;

end.
